
#Per avere l'elenco di tutti gli oggetti creati si usa ls()


# R ha memorizzati dati da utilizzare come esempi 

data() 

str(iris)
hist(iris$Petal.Length)
hist(iris$Petal.Length, xlab="Petal Length", main="Iris", prob=T )

hist(iris$Petal.Length, xlab="Petal Length", main="Iris", prob=T,
col="lightgray", breaks=c(1,1.5,2,4,4.5,5,5.5,6,7) )

#attenzione!
hist(iris$Petal.Length, xlab="Petal Length", main="Histogram", prob=F,
col="lightgray", breaks=c(1,1.5,2,4,4.5,5,5.5,6,7) )

hist(iris$Petal.Length, xlab="Petal Length", main="Iris", prob=T,
col="lightgray", nclass=30 )
curve(dnorm(x, mean=mean(iris$Petal.Length), sd=sd(iris$Petal.Length)), add=T, col="red")


table(iris$Species)
hist(iris$Petal.Length[iris$Species=="setosa"], xlab="Petal Length", main="Histogram", prob=T,
col="lightgray")

hist(iris$Petal.Length[iris$Species=="setosa"], xlab="Petal Length", main="Histogram", prob=T,
col="lightgray", breaks=c(1,1.2,1.35,1.50,1.65,1.9))

hist(iris$Petal.Length[iris$Species=="setosa"], xlab="Petal Length", main="Histogram", prob=T,
col="lightgray",nclas=20)

hist(iris$Petal.Length[iris$Species=="setosa"], xlab="Petal Length", main="Histogram", prob=T,
col="lightgray",nclas=10)

lines(density(iris$Petal.Length[iris$Species=="setosa"]), col="orange",lwd=2)

xxx=seq(1,2,0.001)
lines(xxx,dnorm(xxx,mean=mean(iris$Petal.Length[iris$Species=="setosa"]), 
sd=sd(iris$Petal.Length[iris$Species=="setosa"])),
 col="red",lwd=2)

plot(density(iris$Petal.Length[iris$Species=="setosa"]), col="orange",lwd=2,xlim=c(1,7), main="Iris")
lines(density(iris$Petal.Length[iris$Species=="versicolor"]), col="red",lwd=2)
lines(density(iris$Petal.Length[iris$Species=="virginica"]), col="magenta",lwd=2)




#Proviamo a vedere la struttura del dataset ChickWeight

str(ChickWeight)

# Sono presenti 4 variabili...

# Selezioniamo i dati a 21 giorni

Chick21=ChickWeight[ChickWeight$Time==21,]

#Calcoliamo la media

mean(Chick21$weight)

#la mediana

median(Chick21$weight)

# primo e il terzo quartile

quantile(Chick21$weight)

#la deviazione standard

sd(Chick21$weight)

summary(Chick21$weight)

attach(Chick21)

summary(weight)

summary(weight[Diet==1])
summary(weight[Diet==2])
summary(weight[Diet==3])
summary(weight[Diet==4])

#L'istogramma

hist(weight)
hist(weight, col="blue")
hist(weight, prob=T)
hist(weight, prob=T, nclass=20)

#Confrontiamo l'efficacia delle diverse diete
table(Diet)
plot(Diet,col="darkblue")
plot(table(Diet))

pie(table(Diet))


mean(weight[Diet==1])
mean(weight[Diet==2])
var(weight[Diet==1])
var(weight[Diet==2])

#test F sulle varianze (nelle popolazioni!)
var.test(weight[Diet==1], weight[Diet==2])
curve(df(x,15,9),0,5)
qf(0.025, 15,9)
qf(0.025, 15,9,lower.tail=F)

#test T sui valori medi (delle popolazioni!)

t.test(weight[Diet==1], weight[Diet==2], var.equal=T)
curve(dt(x,24),-3,3)
qt(0.025, 24)

integrate(dt, df=24, -Inf, -1.375)


# **Importiamo un dataset*

# I dati sono contenuti nel file Datipressione.txt

# Per vedere la directory di lavoro usiamo il comando

getwd() #get w(orking) d(irectory)

# Per caricare i dati in R impostiamo come directory di lavoro la directory
# dove si trova il file Datipressione.txt


# importiamo i dati:
Pres=read.table("Datipressione.txt", sep="", na.strings="NA")
str(Pres)

attach(Pres)
summary(PresST0)
summary(PresST2)


hist(PresST0, prob=T, nclass=15)
lines(density(PresST0), col="red", lwd=2)
curve(dnorm(x, mean=mean(PresST0), sd=sd(PresST0)), 120, 190, add=T, col="blue", lwd=2)

hist(PresST2, prob=T, nclass=15)
lines(density(PresST2), col="red", lwd=2)
curve(dnorm(x, mean=mean(PresST2), sd=sd(PresST2)), 100, 160, add=T, col="blue", lwd=2)

plot(density(PresST0), col="red", lwd=2, xlim=c(100,190))
lines(density(PresST2), col="blue", lwd=2)

detach(Pres)
Pres$deltaT0T2=Pres$PresST0-Pres$PresST2

hist(Pres$deltaT0T2, prob=T, nclass=15)

t.test(Pres$PresST0, Pres$PresST2, paired=T)

t.test(Pres$PresST0, Pres$PresST2, paired=T, alternative="greater")

curve(dt(x,299),-3,3, lwd=2, col="blue")

#Siamo ormai prossimi alla densita' Normale(0,1)...

curve(dnorm(x),-3,3, add=T, col="red", lwd=2)

# ...ma non perfettamente 
qt(0.025, 299)
qnorm(0.025)


curve(dt(x,df=2),-4,4,col="yellow",lwd=2, ylim=c(0, 0.4))
curve(dt(x,df=3),-4,4, add=TRUE,col="orange",lwd=2)
curve(dt(x,df=5),-4,4, add=TRUE,col="darkorange",lwd=2)
curve(dt(x,df=10),-4,4, add=TRUE,col="red",lwd=2)
curve(dt(x,df=40),-4,4, add=TRUE,col="darkred",lwd=2)
curve(dt(x,df=300),-4,4, add=TRUE,col="magenta",lwd=2)
curve(dnorm(x),-4,4, add=TRUE,col="blue",lwd=2)

integrate(dt, df=299, 26.023, +Inf)


#Dati qualitativi


library(vcdExtra)

str(esoph)

ttt <- table(esoph$agegp, esoph$alcgp, esoph$tobgp)
o <- with(esoph, order(tobgp, alcgp, agegp))

ttt[ttt == 1] <- esoph$ncases[o]

tt1 <- table(esoph$agegp, esoph$alcgp, esoph$tobgp)

tt1[tt1 == 1] <- esoph$ncontrols[o]

tt <- array(c(ttt, tt1), c(dim(ttt),2),
c(dimnames(ttt), list(c("Cancer", "control"))))
structable(tt)

tabella=margin.table(tt,c(2,4))
tabella=as.table(tabella, dnn=c("Risk factor", "Cancer"))


#La tabella a seguire riporta i risultati di uno studio caso-controllo sui legami tra consumo di alcolici
#e tumore all'esofago

t2=as.table(matrix(c(104, 770, 96, 205), 2, 2, byrow=T))
rownames(t2)=c("<80g/day", ">=80g/day")
colnames(t2)=c("Esoph cancer", "Control")

t2[1, ]/sum(t2[1,])
t2[2, ]/sum(t2[2,])

p1=t2[1,1]/sum(t2[1,])
se.p1=sqrt(p1*(1-p1)/sum(t2[1,]))
ci.p1=c(p1-1.96*se.p1, p1+1.96*se.p1)

p2=t2[2,1]/sum(t2[2,])
se.p2=sqrt(p2*(1-p2)/sum(t2[2,]))
ci.p2=c(p2-1.96*se.p2, p2+1.96*se.p2)

z=(p1-p2)/sqrt((p1*(1-p1)/sum(t2[1,]))+(p2*(1-p2)/sum(t2[2,]))  )
qnorm(0.025)
integrate(dnorm, -Inf, -6.89)

ptot=(t2[1,1]+t2[2,1])/(sum(t2[1,])+sum(t2[2,]))
z=(p1-p2)/sqrt((ptot*(1-ptot))*(1/sum(t2[1,])+1/sum(t2[2,]))  )

prop.test(c(t2[1,1],t2[2,1]), c(sum(t2[1,]), sum(t2[2,])), correct=F )

# La tabella a seguire riporta il numero di pazienti che rispondono e meno a  
due terapie alternative in uno studio cross-over 

mat = as.table(rbind(c(1157, 35), 
                     c( 220, 13) ))
colnames(mat) <- rownames(mat) <- c("No", "Yes")
names(dimnames(mat)) = c("A", "B")
mat
margin.table(mat, 1)
margin.table(mat, 2)
sum(mat)

binom.test(c(220, 35), p=0.5)

mcnemar.test(mat, correct=FALSE)

#Ancora per importare un database

datibio<-read.delim("Gain.txt")
read.delim("Gain.txt", sep="\t", dec=".")
read.csv("Gain.csv", sep=",")
#the separator is white space, that is one or more spaces, tabs, newlines or carriage returns
read.table("Gain.txt", sep="", na.strings="NA")
read.table("C:\\Ale\\Didattica\\Materiali\\R\\Data\\Gain.txt", sep="")
#Per importare files .xlsx potremmo installare il package "xlsx"
library(xlsx)
